<script lang="ts">
  import { browser } from '$app/environment';
  import { onDestroy, onMount } from 'svelte';
  import IslandLinks from './IslandLinks.svelte';

  let dialog: HTMLDivElement;
  let clientX: number;
  let clientY: number;
  let open = false;

  let openHandler: CallbackWith<CustomEvent>;
  let closeHandler: CallbackWith<PointerEvent>;
  let tween: GSAPTween;

  $: open && browser && document.addEventListener('click', closeHandler as EventListener);
  $: !open && browser && document.removeEventListener('click', closeHandler as EventListener);

  onMount(async () => {
    const [gsapModule] = await Promise.all([import('gsap/all')]);

    const gsap = gsapModule.gsap;

    tween = gsap.from(dialog, {
      duration: 0.2,
      scaleX: 0.8,
      scaleY: 0.8,
      ease: 'back.out',
      paused: true,
    });

    const openPopup = (event: CustomEvent) => {
      const eventData = event.detail;
      clientX = eventData.clientX;
      clientY = eventData.clientY;

      // dialog.style.left = clientX + 'px';
      // dialog.style.top = clientY + 'px';
      open = true;
      tween.restart();
    };

    openHandler = openPopup;

    closeHandler = (event: Event) => {
      if (!tween.isActive() && !dialog.contains(event.target as Node)) {
        open = false;
      }
    };

    document.addEventListener('demoEvent', openHandler as EventListener, { capture: true });
  });

  browser &&
    onDestroy(() => {
      document.removeEventListener('demoEvent', openHandler as EventListener);
    });
</script>

<div
  bind:this={dialog}
  role="dialog"
  class="my-container"
  class:open>
  <button on:click={() => (open = false)}>close</button>
  "Neque porro quisquam est qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit..." "There
  is no one who loves pain itself, who seeks after it and wants to have it, simply because it is pain..."
  <IslandLinks />
</div>

<style>
  .my-container {
    position: absolute;
    width: calc(100% - 60px);
    padding: 20px;
    border-radius: 30px;
    margin: 30px;
    margin-top: 100px;
    margin-bottom: auto;
    background-color: white;
    visibility: hidden;
  }

  .open {
    visibility: visible;
  }

  button {
    display: flex;
    margin-left: auto;
  }

  @media (width >= 768px) {
    .my-container {
      width: 400px;
    }
  }
</style>
